<template>
 <div class="main-contain">
    <div class="position">
      <bread-crumb :crumbs='crumbs'></bread-crumb>
    </div>
    <div class="app-container" id="outcome-indicators-query">
      <person-info :patient="patientInfo"></person-info>
      <person-nav activeName="bloodpressure" :patientID="patientID"></person-nav>

      
      <div class="cell clearfix">
        <label class="title">
          <span class="name">日期查询</span> :
        </label>
        <el-date-picker
          v-model="listQuery.start_time"
          prefix-icon="el-icon-date"
          @change="changeTime"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
        <span class>-</span>
        <el-date-picker
          v-model="listQuery.end_time"
          prefix-icon="el-icon-date"
          @change="changeTime"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
      </div>
      
      <div class="cell clearfix">
        <label class="title">
          <span class="name">曲线图</span> :
        </label>
        <div class="time">
          <ul class>
            <li
              :class="item.value==diagramType?'active':''"
              @click="selectDiagramType( item.value)"
              v-for="item in diagramTypeOptions"
              :key="item.value"
            >{{item.label}}</li>
          </ul>
        </div>
      </div>
      
      <div class="cqd-dataTitle">统计图</div>
      <el-row :gutter="32">
        <el-col :xs="24" :sm="24" :lg="24">
          <div class="chart-wrapper">
              <line-chart title="曲线图(mmHg)" :options="CompletionOptions" />
          </div>
        </el-col>
      </el-row>

      <div style="height:20px">&nbsp;</div>
      <div class="cqd-dataTitle">统计表</div>
      <el-table
        ref="multipleTable"
        :data="tableData"
        border
        fit
        highlight-current-row
        style="width: 100%;margin-top: 10px;"
        :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)'}"
      >
        
        <el-table-column  label="透析日期" min-width="80" property="schedule_date" align="center">
          <template slot-scope="scope"><span>{{getTime(scope.row.schedule_date, '{y}{m}{d}')}}</span></template>
        </el-table-column>
        <el-table-column  label="透前血压//mmHg" min-width="80" property="assessment_before_dislysis" align="center" :render-header="renderheader">
          <template slot-scope="scope"><span>{{scope.row.assessment_before_dislysis&&scope.row.assessment_before_dislysis.systolic_blood_pressure&&scope.row.assessment_before_dislysis.diastolic_blood_pressure? scope.row.assessment_before_dislysis.systolic_blood_pressure +'/'+scope.row.assessment_before_dislysis.diastolic_blood_pressure:'--'}}</span></template>
        </el-table-column>
        <el-table-column  label="透析中最低血压//mmHg" min-width="80" property="monitor_records" align="center" :render-header="renderheader">
          <template slot-scope="scope"><span>{{minBloodPressure(scope.row.monitor_records)}}</span></template>
        </el-table-column>
        <el-table-column  label="透析中最高血压//mmHg" min-width="80" property="monitor_records" align="center" :render-header="renderheader">
          <template slot-scope="scope"><span>{{maxBloodPressure(scope.row.monitor_records)}}</span></template>
        </el-table-column>
        <el-table-column  label="透后血压//mmHg" min-width="80" property="assessment_after_dislysis" align="center" :render-header="renderheader">
          <template slot-scope="scope"><span>{{scope.row.assessment_after_dislysis&&scope.row.assessment_after_dislysis.systolic_blood_pressure&&scope.row.assessment_after_dislysis.diastolic_blood_pressure? scope.row.assessment_after_dislysis.systolic_blood_pressure +'/'+scope.row.assessment_after_dislysis.diastolic_blood_pressure:'--'}}</span></template>
        </el-table-column>
        
      </el-table>

      <!-- <pagi-nation title="分页"></pagi-nation> -->

      <el-pagination
      align="right"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="listQuery.pate"
        :page-sizes="[10, 20, 50, 100]"
        :page-size="10"
        background
        style="margin-top:20px;"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>


<script>
import { GetPersonBloodPressureData  } from "@/api/qcd";
import {jsGetAge, uParseTime} from "@/utils/tools";
import personNav from './components/personNav'
import personInfo from './components/personInfo'
import BreadCrumb from "@/xt_pages/components/bread-crumb";
import LineChart from "../../components/LineChart";
export default {
  name: "totalAnalysis",
  data() {
    return {
      crumbs:[
        {path:false, name:'质控管理'},
        {path:false, name:'患者分析'},
        {path:false, name:'统计'},
        {path:false, name:'血压'},
      ],
      total: 0,
      patientMap:{},
      listQuery: {
        start_time: "",
        end_time: "",
        page: 1,
        limit: 10,
      },
      CompletionOptions:{
          xAxis:[],
          legend:[],
          series:[],
      },
      tableData: [],
      pieData:[],
      patientInfo:null,
      patientID:0,
      diagramType:1,
      diagramTypeOptions: [
        { value: 1, label: "透前血压",  },
        { value: 2, label: "透析中最低血压", },
        { value: 3, label: "透析中最高血压", },
        { value: 4, label: "透后血压", },
      ],
    };
  },
  created() {
    var patientID = this.$route.query && this.$route.query.id;
    if(typeof(patientID) == 'undefined' || !patientID || patientID<=0) {
      this.$message.error('参数错误，无法请求');
      return false;
    }
    patientID = parseInt(patientID);
    this.patientID = patientID;
    this.listQuery.patient_id = patientID;

    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.listQuery.end_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    nowDate.setMonth(nowDate.getMonth() - 3);
    nowYear = nowDate.getFullYear();
    nowMonth = nowDate.getMonth() + 1;
    nowDay = nowDate.getDate();
    this.listQuery.start_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    
    this.getList();
  },
  methods: {
    getList() {
      GetPersonBloodPressureData(this.listQuery).then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
            this.tableData = [];
            this.total = response.data.data.total;
            this.patientInfo = response.data.data.patient;
            var bps = response.data.data.bps;
            for (const index in bps) {
                this.tableData.push(bps[index]);
            }
            var pieData = response.data.data.lines;
            for (const index in pieData) {
                this.pieData.push(pieData[index]);
            }
        }
      });
    },
    changeTime() {
      this.getList();
    },
    onSearch(){
      this.getList();
    },
    changeModel() {
      this.getList();
    },
    handleSizeChange(val) {
      this.listQuery.limit = val;
      this.getList();
    },
    handleCurrentChange(val) {
      this.listQuery.page = val;
      this.getList();
    },
    getTime(value, temp) {
        if (value != undefined) {
          return uParseTime(value, temp)
        }
        return ""
    },
    getProjectName(id) {
      return (id in this.projectOptions) ? this.projectOptions[id].project_name:'';
    },
    getPatientName(id) {
      return (id in this.patientMap) ? this.patientMap[id].name:'';
    },
    getPatientLapseto(lapseto) {
      if(lapseto==1) {
        return '留治';
      }else if(lapseto == 2) {
        return '转出';
      }
      return '--';
    },
    getPatientSource(srouce){
      if(srouce==1) {
        return '门诊';
      }else if(srouce == 2) {
        return '住院';
      }
      return '其他';
    },
    getPatientGender(gender) {
      if (gender == 1) {
        return '男';
      } else if(gender == 2) {
        return '女';
      }
      return '';
    },
    tranAge(birthday) {
        var birth = uParseTime(birthday, '{y}-{m}-{d}');
        return jsGetAge(birth, '-');
    },
    getPatientDialysisNo(id) {
      return (id in this.patientMap) ? this.patientMap[id].dialysis_no:'';
    },
    getItemVulue(project_id, item_id, row) {
        var key = project_id + '_' + item_id;
        return (typeof(row.items) !== 'undefined' && (key in row.items)) ? row.items[key].inspect_value:'';
    },
    renderheader(h, { column, $index }) {
        return h('span', {}, [
            h('span', {}, column.label.split('//')[0]),
            h('br'),
            h('span', {}, column.label.split('//')[1])
        ])
    },
    maxBloodPressure(records){
      if (typeof(records) == "undefined" || !records || records.length == 0) {
        return '--';
      }
      var arr = [];
      for (const key in records) {
        arr.push(records[key]);
      }
      if(arr.length == 0) {
        return '--';
      }

      var sortData = this.selectionSort(arr);
      arr = [];
      for (const key in sortData) {
        arr.push(sortData[key]);
      }
      var index = arr.length - 1;
      return arr[index].systolic_blood_pressure + '/' + arr[index].diastolic_blood_pressure
    },
    maxLineBloodPressure(records){
      if (typeof(records) == "undefined" || !records || records.length == 0) {
        return [0, 0];
      }
      var arr = [];
      for (const key in records) {
        arr.push(records[key]);
      }
      if(arr.length == 0) {
        return [0, 0];
      }

      var sortData = this.selectionSort(arr);
      arr = [];
      for (const key in sortData) {
        arr.push(sortData[key]);
      }
      var index = arr.length - 1;
      return [arr[index].systolic_blood_pressure,arr[index].diastolic_blood_pressure];
    },
    minLineBloodPressure(records){
      if (typeof(records) == "undefined" || !records || records.length == 0) {
        return [0, 0];
      }
      var arr = [];
      for (const key in records) {
        arr.push(records[key]);
      }
      if(arr.length == 0) {
        return [0, 0];
      }

      var sortData = this.selectionSort(arr);
      arr = [];
      for (const key in sortData) {
        arr.push(sortData[key]);
      }
      var index = 0;
      return [arr[index].systolic_blood_pressure,arr[index].diastolic_blood_pressure];
    },
    minBloodPressure(records){
      
      if (typeof(records) == "undefined" || !records || records.length == 0) {
        return '--';
      }
      var arr = [];
      for (const key in records) {
        arr.push(records[key]);
      }
      if(arr.length == 0) {
        return '--';
      }

      var sortData = this.selectionSort(arr);
      arr = [];
      for (const key in sortData) {
        arr.push(sortData[key]);
      }
      var index = 0;
      return arr[index].systolic_blood_pressure + '/' + arr[index].diastolic_blood_pressure
    },
    selectionSort(arr) {
      var len = arr.length;
      var minIndex, temp;
      for (var i = 0; i < len - 1; i++) {
          minIndex = i;
          for (var j = i + 1; j < len; j++) {
              if (arr[j].systolic_blood_pressure < arr[minIndex].systolic_blood_pressure || (arr[j].systolic_blood_pressure == arr[minIndex].systolic_blood_pressure && arr[j].diastolic_blood_pressure < arr[minIndex].diastolic_blood_pressure)) {     //寻找最小的数
                  minIndex = j;                 //将最小数的索引保存
              }
          }
          temp = arr[i];
          arr[i] = arr[minIndex];
          arr[minIndex] = temp;
      }
      return arr;
    },
    selectDiagramType(type) {
      this.diagramType = type;
      this.listQuery.diagram_type = type;
      // this.getList();
    },
    drawPie(){
      this.CompletionOptions = {
          xAxis:[],
          legend:[],
          series:[],
      };


      if(this.diagramType < 1 || this.diagramType >4) {
        return false;
      }

      this.CompletionOptions.legend = ['收缩压', '舒张压'];
      this.CompletionOptions.series = [
        { name:'收缩压', type:'line', data:[] },
        { name:'舒张压', type:'line', data:[] },
      ];


      for (const index in this.pieData) {
        var dateDay = uParseTime(this.pieData[index].schedule_date, '{y}-{m}-{d}');
        this.CompletionOptions.xAxis.push(dateDay);
        if (this.diagramType == 1) {
          if (this.pieData[index].assessment_before_dislysis) {
            this.CompletionOptions.series[0].data.push(this.pieData[index].assessment_before_dislysis.systolic_blood_pressure);
            this.CompletionOptions.series[1].data.push(this.pieData[index].assessment_before_dislysis.diastolic_blood_pressure);
          } else {
            this.CompletionOptions.series[0].data.push(0);
            this.CompletionOptions.series[1].data.push(0);
          }
        } else if (this.diagramType == 2){
          var item = this.minLineBloodPressure(this.pieData[index].monitor_records);
          this.CompletionOptions.series[0].data.push(item[0]);
          this.CompletionOptions.series[1].data.push(item[1]);
          
        }else if (this.diagramType == 3){
          var item = this.maxLineBloodPressure(this.pieData[index].monitor_records);
          this.CompletionOptions.series[0].data.push(item[0]);
          this.CompletionOptions.series[1].data.push(item[1]);
          
        }else{
          if (this.pieData[index].assessment_after_dislysis) {
            this.CompletionOptions.series[0].data.push(this.pieData[index].assessment_after_dislysis.systolic_blood_pressure);
            this.CompletionOptions.series[1].data.push(this.pieData[index].assessment_after_dislysis.diastolic_blood_pressure);
          } else {
            this.CompletionOptions.series[0].data.push(0);
            this.CompletionOptions.series[1].data.push(0);
          }
        }
      }
    },
  },
  components: {
      personNav,
      BreadCrumb,
      personInfo,
      LineChart
  },
  watch:{
    "diagramType":function(){
      this.drawPie();
    },
    "pieData":function (){
      this.drawPie();
    },
  }
};
</script>
<style>
#oictable ::-webkit-scrollbar {
  height: 15px;
}
#outcome-indicators-query .el-form-item {
    margin-bottom: 0px !important;
}
</style>


<style rel="stylesheet/scss" lang="scss" scoped>
.app-container {
//   margin: 20px;
  font-size: 15px;
  .filter-container {
    padding-bottom: 5px;
  }
  .cqd-dataTitle{
    color: #303133;
    font-size: 14px;
    border-bottom: 2px #E4E7ED solid;
    height: 36px;
    line-height: 36px;
    margin: 0 0 25px 0;
    position: relative;
  }
  .cqd-dataTitle::before {
      position: absolute;
      left: 0;
      bottom: -2px;
      content: "";
      width: 42px;
      height: 2px;
      background: #409eff;
  }
  .search-component {
    width: 500px;
    .searchBox {
      width: 300px;
      height: 36px;
      line-height: 36px;
      padding-left: 15px;
      border: 1px #dcdfe6 solid;
      border-right: none;
      outline: none;
      float: left;
      border-radius: 6px 0 0 6px;
      font-size: 14px;
      color: #333;
      background: #fff;
      box-shadow: 3px 3px 4px rgba(135, 135, 135, 0.05);
    }
    .searchBtn {
      background-color: #409eff;
      color: #fff;
      font-size: 15px;
      text-align: center;
      height: 36px;
      line-height: 36px;
      float: left;
      outline: none;
      width: 70px;
      border: none;
      border-radius: 0 6px 6px 0;
      font-family: "Microsoft Yahei";
      cursor: pointer;
    }
  }
  .amount {
    font-weight: normal;
    padding: 10px 0 0 0;
    color: #606266;
    font-size: 14px;
    span {
      color: #ef2525;
      font-family: "Arial";
      padding: 0 2px;
    }
  }
}
</style>